package edu.uiuc.dsi;

public abstract class Base
{
	private Core objApplicationCore;
	private String sComponentName;

	public abstract void processPacket(TCPSocket sender, Packet packet);
	public abstract void initializeChildControls();

	public Base(String componentName)
	{
		sComponentName = componentName;
	}
	
	public void setApplicationCore(Core objCore)
	{
		objApplicationCore = objCore;
	}
	
	public Core getApplicationCore()
	{
		return objApplicationCore;
	}
	
	public String getComponentName()
	{
		return sComponentName;
	}
	
	public void write(TCPSocket objTCPSocket, byte[] data)
	{
		Packet objPacket = new Packet(data);
		objPacket.setTargetComponentName(getComponentName());
		
		objApplicationCore.writePacket(objTCPSocket, objPacket);
		
	}
	
	public void broadcast(byte[] data)
	{
		Packet objPacket = new Packet(data);
		objPacket.setTargetComponentName(getComponentName());
		
		objApplicationCore.broadcastPacket(objPacket);
	}
	
	public TCPSocket[] getActiveTCPSockets()
	{
		return objApplicationCore.getActiveTCPSockets();
	}
	
	public TCPSocket getSelfTCPSocket()
	{
		return objApplicationCore.getSelfTCPSocket();
	}
	
}

